
      * image access from COBOL -- lars appel 11.feb.02

       IDENTIFICATION DIVISION.
       PROGRAM-ID.  demo.

       DATA DIVISION.
       WORKING-STORAGE SECTION.

       01  END-OF-CHAIN                       PIC  S9(4)  COMP VALUE 15.
       01  END-OF-DATA-SET                    PIC  S9(4)  COMP VALUE 11.
       01  NO-CHAIN-HEAD                      PIC  S9(4)  COMP VALUE 17.
       01  NO-SUCH-ENTRY                      PIC  S9(4)  COMP VALUE 17.
       01  ENTRY-HAS-NO-DATA                  PIC  S9(4)  COMP VALUE 17.

       01  DBNAME.
           05  BASEID                         PIC  X(02).
           05  BASENAME                       PIC  X(06).
           05  TERMINATOR                     PIC  X(02).

       01  PASSWORD                           PIC  X(10).

       01  STATUS1.
           05  CONDITION                      PIC  S9(4)  COMP.
           05  LENGTH1                        PIC  S9(4)  COMP.
           05  RECORD-NUMBER                  PIC  S9(9)  COMP.
           05  CHAIN-COUNT                    PIC  S9(9)  COMP.
           05  BACK-POINTER                   PIC  S9(9)  COMP.
           05  FORWARD-POINTER                PIC  S9(9)  COMP.

       01  OPTION                             PIC  S9(4)  COMP.

       01  DB-MODE                            PIC  S9(4)  COMP.

       01  LIST                               PIC  X(80).

       01  products-set                       PIC  X(16).

       01  products-buf.
       05    product-no    pic x(6).
       05    product-name  pic x(16).
       05    price         pic s9(7) packed-decimal.
       05    product-line  pic x(2).
       05    quantity      pic s9(4) binary.

       01  dummy                              PIC S9(4)  COMP.


       PROCEDURE DIVISION.
       begin-here.

           display "opening db..."

           MOVE "  TOYDB;" TO dbname
           MOVE "reading;" TO PASSWORD

           MOVE 1 TO DB-MODE

           CALL intrinsic "DBOPEN" USING
             DBNAME, PASSWORD, DB-MODE, STATUS1

           IF CONDITION NOT = 0 THEN
             call intrinsic "DBEXPLAIN" using status1
             go to finish-now
           END-IF

           display "listing products..."

           move "PRODUCTS;" to products-set
           move "@;" to list

           move 2 to db-mode

           perform with test after until condition not = 0

             CALL intrinsic "DBGET" USING
               DBNAME, products-set, DB-MODE, STATUS1, LIST,
               products-buf, dummy

             if condition = 0 then
               display product-no, "  ", product-name, "  ", quantity
             end-if

           end-perform

           if condition not = END-OF-DATA-SET then
             call intrinsic "DBEXPLAIN" using status1
             go to finish-now
           end-if

           display "closing db..."

           MOVE 1 TO DB-MODE

           CALL intrinsic "DBCLOSE" USING
             DBNAME, password, DB-MODE, STATUS1

           IF CONDITION NOT = 0 THEN
             call intrinsic "DBEXPLAIN" using status1
             go to finish-now
           END-IF.

       finish-now.
           stop run.

       end program demo.


